angular.module('addEditNasModule', ['ngDialog', 'angulartics', 'angulartics.google.analytics'])
.config(['ngDialogProvider', function (ngDialogProvider) {
        ngDialogProvider.setDefaults({
            plain: false,
            showClose: true,
            closeByDocument: true,
            closeByEscape: true,
            appendTo: false,
            preCloseCallback: function (value) {

            }
        });
    }])
.controller('addEditNasModuleController', ['$scope', '$rootScope', '$http', 'ngDialog', '$analytics',
    function($scope, $rootScope, $http, ngDialog, $analytics) {
        $scope.assetNAS={};
        $scope.assetNAS.properties={};
        $scope.assetNAS.usage='source';
        $scope.assetNAS.type=4;
        $scope.applianceList=[];

    if($scope.isEdit){
        console.log($scope.assetList);
        $scope.dialogTitle='Edit';
        $scope.assetNAS.name=$scope.assetList.name;
        $scope.assetNAS.properties.hostname = $scope.assetList.nas_properties.hostname;
        $scope.assetNAS.properties.nas_id   =   $scope.assetList.nas_properties.nas_id;
        $scope.assetNAS.properties.protocol = $scope.assetList.nas_properties.protocol;
        $scope.assetNAS.properties.port =  parseInt($scope.assetList.nas_properties.port);
        $scope.assetNAS.properties.share_name = $scope.assetList.nas_properties.share_name;
        $scope.assetNAS.properties.username = $scope.assetList.nas_properties.username;
    }else{
        $scope.dialogTitle='Add';
        $scope.assetNAS.properties.protocol = 'nfs';
        $scope.assetNAS.properties.port=2049;
    }
    $http({
        method: 'get',
        url : '/api/systems'
    }).success(function(data, status, headers){
         console.log('data');
          console.log(data);
        for (var i=0 ;  i< data.appliance.length; i++){
            var obj={
                id:data.appliance[i].id,
                name:data.appliance[i].name
            }
             $scope.applianceList.push(obj);
        }
        $scope.assetNAS.system = ($scope.isEdit)?$scope.assetList.system_id: $scope.applianceList[0].id;
      }).error(function(response){
        
    });
    $scope.launchRetentionManager = function() {
        resp = PHD.Ajax.get("/api/retention/strategy/" + "?sid=" + PHD.appliance_sid );
        resp.done(function(data){
            var result = data.data;
            var strategy = result.strategy;
            if (strategy == 'MinMax') {
                ngDialog.open({
                    template: 'app/configure/retention/min-max.html',
                    overlay: true,
                    name: 'MinMaxRetention',
                    data:$scope.assetList,
                    ngDialogStyle:'width:700px; height:440px;',
                    closeByDocument: false,
                    closeByEscape: false
                });
            } else {
                ngDialog.open({
                    template: 'app/configure/retention/retentionpolicy.html',
                    scope: $scope,
                    overlay:true,
                    name: 'Retention-Policy',
                    ngDialogStyle:'width:300px; height:400px;',
                    // GFS TODO - enlarge dialog once we have weekly/monthly/yearly settings
                    //ngDialogStyle:'width:700px; height:400px;',
                    closeByDocument: false,
                    closeByEscape: false
                });
            }
        });

    };
    $scope.validation = function(){
            $scope.nasName = false;
            $scope.nasIp = false;
            $scope.nasShareName = false;
        var FQDN_REGEXP = /^(([a-zA-Z0-9]|[a-zA-Z0-9][a-zA-Z0-9\-]*[a-zA-Z0-9])\.)*([A-Za-z0-9]|[A-Za-z0-9][A-Za-z0-9\-]*[A-Za-z0-9])(\:[0-9]{1,5})?$/i;
        var NAME_REGEXP = /^[a-zA-Z0-9_-]*$/;
        if (typeof $scope.assetNAS.name == 'undefined' || !FQDN_REGEXP.test($scope.assetNAS.name)){
            $scope.nasName = true;
            return false;
        }else if (typeof $scope.assetNAS.properties.hostname == 'undefined' || $scope.assetNAS.properties.hostname == '' || !FQDN_REGEXP.test($scope.assetNAS.properties.hostname)){
            $scope.nasIp = true;
            return false;
        }else if (typeof $scope.assetNAS.properties.share_name == 'undefined' || $scope.assetNAS.properties.share_name == ''){
            $scope.nasShareName = true;
            return false;
        }else {
            $scope.nasName = false;
            $scope.nasIp = false;
            $scope.nasShareName = false;
            return true;
        }

    }
    $scope.changePort = function(){
        if($scope.assetNAS.properties.protocol == "nfs") {
           $scope.assetNAS.properties.port=2049;
        } else {
            $scope.assetNAS.properties.port=445;
        }
    }

    $scope.showtoolTipForEmailVerification = function(){
        var form = angular.element("#form-server");
        form.find(".definition").popover({
            appendTo: form
        });
    }  
    $scope.saveNAS = function(){
        if ($scope.validation()){
            var url='';
            var httpMethod='';
            var dataObject={};
            if($scope.isEdit){
                dataObject.properties=$scope.assetNAS.properties;
                dataObject.usage =$scope.assetNAS.usage;
                dataObject.type=$scope.assetNAS.type; 
                url ='/api/storage/'+ $scope.assetNAS.properties.nas_id+'/?sid='+$scope.assetList.system_id;
                httpMethod='put'
               }else{
                dataObject=$scope.assetNAS;
                url ='/api/storage/?sid='+$scope.assetNAS.system;
                httpMethod='post';
             }
            var load = PHD.showLoadingIndicator("body", true, "Saving...");
            $http ({
                method: httpMethod,
                url : url,
                data: JSON.stringify(dataObject)
                }).success(function(data){
                    PHD.hideLoadingIndicator(load);
                    $(document).trigger("assetChange");
                    $scope.checkTourOnOff();
                    ngDialog.close('add-edit-nas-dailog');
                }).error(function(response) {
                    PHD.hideLoadingIndicator(load);
                    ngDialog.open({
                        dialogType:'retry',
                        dialogMessage:response.result[0].message
                    })
                });

        }
    }
    
    $scope.closedAddEditNASDlg = function(){
        $scope.checkTourOnOff();
    }
    
    $scope.checkTourOnOff = function(){
        ngDialog.close("addeditnasdailogId"); 
        if(resetTour){
            refreshPage();
            setTimeout(function(){
                var $scope = $("[ng-controller=GlobalCtrl]").scope();
                $scope.user.showTour = true;
                window.location.href = "#/dashboard/"; 
                resetTour = false;
                $(".btn-pref-cancel").trigger('click');
            }, 1000);
         }
    }
      
  }]);